﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private parserHisto As SaxParser
	Private start As Long
	Private pCaller As Object
	Private pCallBackSub As String
	Private pSQL As SQL
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Caller As Object, CallBackSub As String, DB As SQL)
	pCaller = Caller
	pCallBackSub = CallBackSub
	pSQL = DB
	parserHisto.Initialize
End Sub

'Do the parsing of the File who the name is passed as FileName
'and udpdate the database pSQL with the data into the XML file
Public Sub XMLParse(tInput As InputStream)
	Dim tempSTR As String
	tempSTR = "DROP TABLE IF EXISTS HistoRates" & Main.NameCur.ToUpperCase
	pSQL.ExecNonQuery(tempSTR)
	'Crée la table vide
	tempSTR = "CREATE TABLE HistoRates"  & Main.NameCur.ToUpperCase & " (Date TEXT, Rate REAL)"
	pSQL.ExecNonQuery(tempSTR)
	pSQL.BeginTransaction
	'Do the parsing
	start = DateTime.Now
	parserHisto.Parse(tInput,"parserECBHisto")
End Sub

Sub parserECBHisto_StartElement (Uri As String, Name As String, Attributes As Attributes)
	'The parsing method, we use only parser_StartElement, because in the xml file
	'the currency and the rates are put in attributes of the Element and we need to
	'get these values not the others. Of course we does a test on the attributes and
	'the name who is "Cube" when the values of rates are passed in the xml file. But
	'some lines are also named "Cube" with nothing after, then we test also attributes
	If ((Name = "Obs") AND (Attributes.Size <> 0)) Then
		Dim mdate As String
		Dim mrate As Double
		If (Attributes.GetName(0) = "TIME_PERIOD") Then mdate = Attributes.GetValue(0)
'			tempdate = Attributes.GetValue(0)
'		End If
		If (Attributes.GetName(1) = "OBS_VALUE") Then mrate = Attributes.GetValue(1)
'			DoEvents
			'Put the new record
		Dim tmpStr As String
		tmpStr = "INSERT INTO HistoRates" & Main.NameCur.ToUpperCase & " VALUES(?,?)"
		pSQL.ExecNonQuery2(tmpStr, Array As Object(mdate,mrate))
'		End If
	End If
End Sub

Sub parserECBHisto_EndElement(Uri As String, Name As String, Text As StringBuilder)
	DoEvents
	If (Name = "Series") Then
		Main.mySQL.TransactionSuccessful
		Main.mySQL.EndTransaction
		Dim intHour, intMin, intSec As Int
		intHour = ((DateTime.Now - start)/DateTime.TicksPerHour)
		intMin = (((DateTime.Now - start)-(intHour*DateTime.TicksPerHour))/DateTime.TicksPerMinute)
		intSec = (((DateTime.Now - start)-(intMin*DateTime.TicksPerMinute))/DateTime.TicksPerSecond)
		Log("Durée after compute: " & intHour & ":" & intMin & ":" & intSec)
		Log("Durée wo compute: " & DateTime.Time(DateTime.Now - start))
		CallSubDelayed2(pCaller, pCallBackSub, True)
	End If
End Sub
